#####
#
#  Channel guardian 1.0 by hd2000 <winstonlim@visto.com>
#
######

######
#
#  type .help , by default it should  list u the help list
#
######


#set prefix for the trigger 
set guardprefix "."

#set the triggers

set guardhelp "help"
set guardop "op"
set guarddeop "deop"
set guardvoice "voice"
set guarddevoice "devoice"
set guardban "ban"
set guardkick "kick"
set guardkickban "kickban"

#set method the bot will be message 
set guardmethod "notice"

#####

#set version
set guardversion "1.1"

#set scriptname 
set guardscript "Channel Guardian"

#####  

if {![info exists newguardop]} {append newguardop $guardprefix $guardop}
if {![info exists newguarddeop]} {append newguarddeop $guardprefix $guarddeop}
if {![info exists newguardvoice]} {append newguardvoice $guardprefix $guardvoice}
if {![info exists newguarddevoice]} {append newguarddevoice $guardprefix $guarddevoice}
if {![info exists newguardban]} {append newguardban $guardprefix $guardban}
if {![info exists newguardkick]} {append newguardkick $guardprefix $guardkick}
if {![info exists newguardkickban]} {append newguardkickban $guardprefix $guardkickban}
if {![info exists newguardhelp]} {append newguardhelp $guardprefix $guardhelp}

bind pub -|- $newguardhelp pub:help
bind pub -|- $newguardop pub:op
bind pub -|- $newguarddeop pub:deop
bind pub -|- $newguardvoice pub:voice
bind pub -|- $newguarddevoice pub:devoice
bind pub -|- $newguardban pub:ban
bind pub -|- $newguardkick pub:kick
bind pub -|- $newguardkickban pub:kickban

####

proc pub:help {nick host handle chan text} { 
  global botnick guardmethod newguardhelp newguardop newguarddeop newguardvoice newguarddevoice newguardban newguardkick newguardkickban guardscript guardversion 
     
  set help {

  " $guardscript $guardversion by hd2000  "
  ""
  " PUB commands :"
  ""
  " $newguardhelp     - display this help " 
  " $newguardop       - $newguardop <nick1> <nick2> "
  " $newguarddeop     - $newguarddeop <nick1> <nick2> "
  " $newguardvoice    - $newguardvoice <nick1> <nick2> "
  " $newguarddevoice  - $newguarddevoice <nick1> <nick2> "
  " $newguardban      - $newguardban <nick1> <nick2> "
  " $newguardkick     - $newguardkick <nick1> <nick2> "
  " $newguardkickban  - $newguardkickban <nick1> <nick2> " 
   }

     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
           foreach h $help {
              putserv "$guardmethod $nick : [subst $h]"
             } 
     } else {
         putserv "$guardmethod $nick : You are not on $chan or you don't have access"
     }
   } 

proc pub:op {nick host handle chan text} { 
  global botnick guardmethod 
     
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
           foreach h [string tolower [split $text]] {
              pushmode $chan +o $h
         }
       flushmode $chan 
     } else {
         putserv "$guardmethod $nick : You are not on $chan or you don't have access"
     }
   } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
  } 
}

proc pub:deop {nick host handle chan text} { 
  global botnick guardmethod 
    
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
           
           foreach h [string tolower [split $text]] {
              if{$h != $botnick} { 
                 pushmode $chan -o $h
                } else { 
                  putserv "$guardmethod : $nick, u moron, trying to deop me ?"
           } 
          } 
       flushmode $chan
     } else {
         putserv "$guardmethod $nick : You are not on $chan or you don't
have access"
     }
   } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
  } 
}

proc pub:voice {nick host handle chan text} { 
  global botnick guardmethod 
    
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
             
           foreach h [string tolower [split $text]] {
              pushmode $chan +v $h
              
           } 
         flushmode $chan
     } else {
         putserv "$guardmethod $nick : You are not on $chan or you don't
have access"
     }
   } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
  } 
}

proc pub:devoice {nick host handle chan text} { 
  global botnick guardmethod 
    
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
              
           foreach h [string tolower [split $text]] {
              pushmode $chan -v $h
            }
             flushmode $chan
     } else {
         putserv "$guardmethod $nick : You are not on $chan or you don't have access"
     }
   } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
  } 
}

proc pub:ban {nick host handle chan text} { 
  global botnick guardmethod 
  
  set chan $chan
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
              
           foreach h [string tolower [split $text]] {
              set m [maskhost [getchanhost $h $chan]] 
              if {[maskhost $botname] != $m} {
                    newchanban $chan $m $nick "requested by $nick" 
              } else {
                putserv "$guardmethod : $nick whats wrong with u ?"
           }
          } 
     } else {
         putserv "$guardmethod $nick : You are not on $chan or you don't have access"
     }
   } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
  } 
}

proc pub:kick {nick host handle chan text} { 
  global botnick guardmethod 
    
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
             foreach h [string tolower [split $text]] {
               if {$botnick != $h} {  
                   putserv "kick $chan $h : requested by $nick"
                 } else {
                   putserv "$guardmethod $nick : Maybe I should kick u"    
           } 
          } 
     } else {
         putserv "$guardmethod $nick : You are not on $guard or you don't have access"
     }
   } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
  } 
}

proc pub:kickban {nick host handle chan text} { 
  global botnick guardmethod 
    
  if {[botisop $chan]} {
     if {[onchan $nick $chan] && [matchattr $handle o|o $chan]} {
           foreach h [string tolower [split $text]] {
              if {$botnick != $h} {  
                set m [maskhost [getchanhost $h $chan]]
                newchanban $chan $m $nick "requested by $nick"
                puthelp "kick $chan $h : requested by $nick"
              } else {
                  putserv "$guardmethod $nick : :P"
              } 
   }
  } else {
             putserv "$guardmethod $nick : You are not on $chan or you don't have access"
  }
 } else {
      putserv "$guardmethod $nick  : $botnick is not opped on $chan"
 }     
}

putlog "$guardscript $guardversion  by hd2000 loaded"


